'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.right = exports.left = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _option = require('./option.js');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/* eslint-disable no-use-before-define */
var AbstractEither = function AbstractEither() {
  _classCallCheck(this, AbstractEither);

  this.left = new LeftProjection(this);
  this.right = new RightProjection(this);
};

var LeftProjection = function () {
  function LeftProjection(e) {
    _classCallCheck(this, LeftProjection);

    this.e = e;
  }

  _createClass(LeftProjection, [{
    key: 'get',
    value: function get() {
      var e = this.e;

      if (e.isLeft === true) {
        return e.leftValue;
      } else {
        throw new Error('Either.left.value on Right');
      }
    }
  }, {
    key: 'map',
    value: function map(f) {
      var e = this.e;

      return e.isLeft === true ? left(f(e.leftValue)) : right(e.rightValue);
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      var e = this.e;

      return e.isLeft === true ? f(e.leftValue) : right(e.rightValue);
    }
  }, {
    key: 'getOrElse',
    value: function getOrElse(def) {
      var e = this.e;

      return e.isLeft === true ? e.leftValue : def;
    }
  }, {
    key: 'filter',
    value: function filter(p) {
      var e = this.e;

      if (e.isLeft === true && p(e.leftValue)) {
        return (0, _option.some)(e);
      } else {
        return _option.none;
      }
    }
  }, {
    key: 'toOption',
    value: function toOption() {
      var e = this.e;

      return e.isLeft === true ? (0, _option.some)(e.leftValue) : _option.none;
    }
  }]);

  return LeftProjection;
}();

var RightProjection = function () {
  function RightProjection(e) {
    _classCallCheck(this, RightProjection);

    this.e = e;
  }

  _createClass(RightProjection, [{
    key: 'get',
    value: function get() {
      var e = this.e;

      if (e.isRight === true) {
        return e.rightValue;
      } else {
        throw new Error('Either.right.value on Left');
      }
    }
  }, {
    key: 'map',
    value: function map(f) {
      var e = this.e;

      return e.isRight === true ? right(f(e.rightValue)) : left(e.leftValue);
    }
  }, {
    key: 'flatMap',
    value: function flatMap(f) {
      var e = this.e;

      return e.isRight === true ? f(e.rightValue) : left(e.leftValue);
    }
  }, {
    key: 'getOrElse',
    value: function getOrElse(def) {
      var e = this.e;

      return e.isRight === true ? e.rightValue : def;
    }
  }, {
    key: 'filter',
    value: function filter(p) {
      var e = this.e;

      if (e.isRight === true && p(e.rightValue)) {
        return (0, _option.some)(e);
      } else {
        return _option.none;
      }
    }
  }, {
    key: 'toOption',
    value: function toOption() {
      var e = this.e;

      return e.isRight === true ? (0, _option.some)(e.rightValue) : _option.none;
    }
  }]);

  return RightProjection;
}();

var Left = function (_AbstractEither) {
  _inherits(Left, _AbstractEither);

  function Left(leftValue) {
    _classCallCheck(this, Left);

    var _this = _possibleConstructorReturn(this, (Left.__proto__ || Object.getPrototypeOf(Left)).call(this));

    _this.isLeft = true;
    _this.isRight = false;

    _this.leftValue = leftValue;
    return _this;
  }

  return Left;
}(AbstractEither);

var Right = function (_AbstractEither2) {
  _inherits(Right, _AbstractEither2);

  function Right(rightValue) {
    _classCallCheck(this, Right);

    var _this2 = _possibleConstructorReturn(this, (Right.__proto__ || Object.getPrototypeOf(Right)).call(this));

    _this2.isLeft = false;
    _this2.isRight = true;

    _this2.rightValue = rightValue;
    return _this2;
  }

  return Right;
}(AbstractEither);

var left = exports.left = function left(leftValue) {
  return new Left(leftValue);
};
var right = exports.right = function right(rightValue) {
  return new Right(rightValue);
};

exports.default = {
  left: left,
  right: right
};